#ifndef CITY_H
#define CITY_H

#include "vec.h"
//#include "glenable.h"
#include "rockets.h"
#include "explosion.h"
#include "player.h"

#define TIME_LAPSE 2.5
#define MIN_TIME_LAPSE 1
#define RADIUS 0.04
#define MIN_RADIUS 0.02
#define UCON_NONE -1
#define UCON_DROP -2
#define UCON_DEAD -3
#define INIT_HEALTH 5
#define ROCKET_RATE 1.5
extern const float pi;
extern int dead;
extern vec2f Max;
extern vec2f Min;

#include <set>

class Rockets;

class City {

	protected:
		vec2f position;
		float rotation;
		set<int> cityPlayers;
		int cityNum;
		float radius;
		float maxRadius;
		float minRadius;
		bool destroyed;
		float r;
		float g;
		float b;
		float spd;
		int missilesFiredAt;
		float lastFiredAtTime;
		float lastPainTime;
		int health;
		bool isCiv;

		virtual void init(Explosions * expld);
		virtual void getColour(const int switchNum);

	public:
		Rockets *rockets;
		Rockets *aimedRockets;

	public:
		City(int num, vec2f pos, Explosions * expld);
		City(int num, float x, float y, Explosions * expld);
		~City();
		virtual void Draw() const;
		void update(float dt);
		int GetNumPlayers() const;
		set<int> GetPlayers() const;
		virtual bool SetPlayer(const int ref);
		void DropPlayer(const int ref);
		float Radius() const;
		void SetRadius(const float rad);
		void SetRotation(const float rot);
		virtual void SetPosition(const vec2f pos);
		float Rotation() const;
		void FireMissile(const vec2f playerAim, const float playerPower);
		virtual bool IsControlled() const;
		virtual bool IsActive() const;
		virtual bool ReadyToBeFiredAt(bool aimedAt);
		vec2f Pos() const;
		virtual void MissileFiredAt();
		void MissileDestroy(int i, bool enemy);
		bool TakeDamage(int amount);
		void Destroyed();
		bool IsAlive() const;
		bool IsCiv() const;
		void SetY(const float yVal);
};

void applyColour(int pn);
string getColourString(int pn);

#endif