#include "CityCiv.h"
#include "glenable.h"
#include "control.h"

extern int currPlayers;

CityCiv::CityCiv(int num, float x, float y, Explosions * expld) : City(num,x,y,expld)
{
	cityNum = num;
	position.x = x;
	position.y = y;
	init(expld);
	lastFiredAtTime = clock()+RAND_UNIT*10000;
	isCiv = true;
	type = RAND_UNIT*2;
}

CityCiv::CityCiv(int num, vec2f pos, Explosions * expld) : City(num,pos,expld)
{
	cityNum = num;
	position = pos;
	init(expld);
	lastFiredAtTime = clock()+RAND_UNIT*10000;
	isCiv = true;
	type = RAND_UNIT*2;
}

void CityCiv::Draw() const
{
	#ifdef HIGH_QUAL
	glDisable(GL_POINT_SMOOTH);
	#endif
	glPushAttrib(GL_CURRENT_BIT);
		aimedRockets -> drawPoints();
	glPopAttrib();
	if(destroyed)
		return;
	glPushMatrix();
		glPushAttrib(GL_CURRENT_BIT);
			glColor3f(1,1,1);
			glPointSize(2);
			glLineWidth(2);

			if(type == 0){
				glBegin(GL_LINE_LOOP);
					glVertex2f(position.x + radius, position.y);
					glVertex2f(position.x + radius, position.y + radius*2);
					glVertex2f(position.x, position.y + radius*2);
					glVertex2f(position.x, position.y);

					glVertex2f(position.x - radius, position.y);
					glVertex2f(position.x - radius, position.y + radius);
					glVertex2f(position.x, position.y + radius);
					glVertex2f(position.x, position.y);
				glEnd();
				glBegin(GL_POINTS);
					glVertex2f(position.x + radius/2, position.y + radius/2);
					glVertex2f(position.x + radius/4*3, position.y + radius/2);
					glVertex2f(position.x + radius/4, position.y + radius/2);
					glVertex2f(position.x + radius/2, position.y + radius);
					glVertex2f(position.x + radius/4*3, position.y + radius);
					glVertex2f(position.x + radius/4, position.y + radius);
					glVertex2f(position.x + radius/2, position.y + radius*1.5);
					glVertex2f(position.x + radius/4*3, position.y + radius*1.5);
					glVertex2f(position.x + radius/4, position.y + radius*1.5);

					glVertex2f(position.x - radius/2, position.y + radius/4);
					glVertex2f(position.x - radius/4*3, position.y + radius/4);
					glVertex2f(position.x - radius/4, position.y + radius/4);
					glVertex2f(position.x - radius/2, position.y + radius/1.5);
					glVertex2f(position.x - radius/4*3, position.y + radius/1.5);
					glVertex2f(position.x - radius/4, position.y + radius/1.5);
				glEnd();
			}
			else{
				glBegin(GL_LINE_LOOP);
					glVertex2f(position.x + radius, position.y + radius*2);
					glVertex2f(position.x + radius, position.y);
					glVertex2f(position.x, position.y);
					glVertex2f(position.x, position.y + radius*2);

					glVertex2f(position.x - radius, position.y + radius);
					glVertex2f(position.x - radius, position.y);
					glVertex2f(position.x, position.y);
					glVertex2f(position.x, position.y + radius);
				glEnd();
				glBegin(GL_POINTS);
					glVertex2f(position.x + radius/2, position.y + radius/4);
					glVertex2f(position.x + radius/4*3, position.y + radius/4);
					glVertex2f(position.x + radius/4, position.y + radius/4);
					glVertex2f(position.x + radius/2, position.y + radius/1.5);
					glVertex2f(position.x + radius/4*3, position.y + radius/1.5);
					glVertex2f(position.x + radius/4, position.y + radius/1.5);

					glVertex2f(position.x - radius/2, position.y + radius/4);
					glVertex2f(position.x - radius/4*3, position.y + radius/4);
					glVertex2f(position.x - radius/4, position.y + radius/4);
					glVertex2f(position.x - radius/2, position.y + radius/1.5);
					glVertex2f(position.x - radius/4*3, position.y + radius/1.5);
					glVertex2f(position.x - radius/4, position.y + radius/1.5);
				glEnd();
			}
			glPointSize(1);
			glLineWidth(1);
		glPopAttrib();
	glPopMatrix();
	#ifdef HIGH_QUAL
	glEnable(GL_POINT_SMOOTH);
	#endif
}

bool CityCiv::IsControlled() const
{
	return true;
}

bool CityCiv::SetPlayer(const int ref)
{
	return false;
}

bool CityCiv::IsActive() const
{
	return true;
}

bool CityCiv::ReadyToBeFiredAt(bool aimedAt)
{
	float timer = RAND_UNIT*10000;
	int missiles = currPlayers;

	//if(timer >= MIN_TIME_LAPSE*2)
	//	timer = MIN_TIME_LAPSE*2;
	if(missiles >= cMax)
		missiles = cMax;

	return (!destroyed && (clock() - lastFiredAtTime) * 0.001 >= timer && aimedRockets -> size() < missiles);
}