#include "cityEarth.h"
#include "glenable.h"

CityEarth::CityEarth(int num, float x, float y, Explosions * expld) : City(num,x,y,expld)
{
	correctRotation();
}

CityEarth::CityEarth(int num, vec2f pos, Explosions * expld) : City(num,pos,expld)
{
	correctRotation();
}

void CityEarth::Draw() const
{
	glPushAttrib(GL_CURRENT_BIT);
		rockets -> drawPoints();
		aimedRockets -> drawPoints();
	glPopAttrib();
	if(destroyed)
		return;
	glPushMatrix();
		glPushAttrib(GL_CURRENT_BIT);
			glPushMatrix();
				glTranslatef(position.x,position.y,0);
				glRotatef(-rotation,0,0,1);
				applyColour(*(cityPlayers.begin()));
				
				glLineWidth(2);
				drawCircle(radius,32);
			glPopMatrix();

			glBegin(GL_LINES);
				float angle = (90 - rotation) * pi / 180;
				glVertex2f(position.x - cosf(angle) * radius * 1.5, position.y - sinf(angle) * radius * 1.5);
				glVertex2f(position.x + cosf(angle) * radius * 1.5, position.y + sinf(angle) * radius * 1.5);
			glEnd();
			glPointSize(2);
			glBegin(GL_POINTS);
				glVertex2f(position.x + cosf(angle) * radius * 2.5, position.y + sinf(angle) * radius * 2.5);
				glVertex2f(position.x + cosf(angle) * radius * 5, position.y + sinf(angle) * radius * 5);
				glVertex2f(position.x + cosf(angle) * radius * 10, position.y + sinf(angle) * radius * 10);
				glVertex2f(position.x + cosf(angle) * radius * 20, position.y + sinf(angle) * radius * 20);
				glVertex2f(position.x + cosf(angle) * radius * 40, position.y + sinf(angle) * radius * 40);
			glEnd();
			glPointSize(1);
			glLineWidth(1);
		glPopAttrib();
	glPopMatrix();
}

bool CityEarth::SetPlayer(const int ref)
{
	if(cityPlayers.size() != 0)
		return false;
	City::SetPlayer(ref);
	getColour(*(cityPlayers.begin()));
	rockets -> changeColour(r,g,b);
	return true;
}

void CityEarth::SetPosition(const vec2f pos)
{
	City::SetPosition(pos);
	correctRotation();
}

void CityEarth::correctRotation()
{
	rotation = atan2(position.x,position.y) * 180 / pi;
}

bool CityEarth::IsActive() const
{
	return IsControlled();
}

bool CityEarth::ReadyToBeFiredAt(bool aimedAt)
{
	return false;
}

void CityEarth::getColour(const int switchNum)
{
	switch(switchNum) {
		case 0:
			r = 0;
			g = 0;
			b = 1;
			break;
		case 1:
			r = 1;
			g = 1;
			b = 0;
			break;
		case 2:
			r = 0;
			g = 1;
			b = 0;
			break;
		case 3:
			r = 1;
			g = 0;
			b = 1;
			break;
		case 4:
			r = 0;
			g = 1;
			b = 1;
			break;
		case 5:
			r = 0.5;
			g = 0.5;
			b = 1;
			break;
		case 6:
			r = 0.2;
			g = 1;
			b = 0.2;
			break;
		case 7:
			r = 0.2;
			g = 0.5;
			b = 0.8;
			break;
		default:
			r = 1;
			g = 1;
			b = 1;
			break;
	}
}