#ifndef CONTROL_H
#define CONTROL_H

#include "glenable.h"
#include "projectiles.h"
#include "rockets.h"
#include "explosion.h"
#include "earth.h"

#include <cmath>

#define PRE_TIME 3
#define POST_GAME_DELAY 3

#define MAX_OFF_MISSILES 3

#define SCREEN_MAX_X 1
#define SCREEN_MAX_Y 1
#define SCREEN_MIN_X -1
#define SCREEN_MIN_Y -1

#define RAND_UNIT (rand()/(float)RAND_MAX)
#define MAX_CITIES 8
#define KEYBOARD_CHECK_TIME 5
#define SCORE_INCREASE 5

extern int gameMode;

void init();
int initKeyboard(int kbn);
void display();
int getPositionPoint(vec2f posPoint);
void deformGround(int point);
void flattenGround(int point);
void drawGround();
int getRotationPoint(vec2f rotPoint);
void drawScore(const float xpos, const float ypos);
void update(float dt);
void keyUp(unsigned short key, int keyboardRef);
void keyDown(unsigned short key, int keyboardRef);
int searchForPlayer(int kbn);
int getNextAvailCity();
void checkForDroppedPlayers();
int getNextCity();
float setYBase();
int getNumAliveCities();
void resetGame();
int getUncontrolledCity();
void setPlayerAimLimits(const int city);
void unRestrictAiming();
void levelCities();
int numCivCities();
bool checkEndGame();

#endif