#include "display.h"

const int playerTextX = nWidth * 0.25;	// for the text at the start
const int playerTextY = nHeight * 0.4;

void displayStandardGame()
{
	glPushMatrix();
		drawGround();
		drawCities();
		drawPlayers();
		drawPowerPoints(false);

		drawScore(nWidth/3,nHeight - 20);
		explosions.drawPoints();
		missiles.drawPoints();
		pinger.drawPoints();
	glPopMatrix();
}

void displayHalfGame()
{
	glPushMatrix();
		drawGround();
		drawCities();
		drawPlayers();
		drawPowerPoints(false);

		drawScore(nWidth/3,nHeight - 20);
		explosions.drawPoints();
		missiles.drawPoints();
		pinger.drawPoints();
	glPopMatrix();
}

void drawEarthGame()
{
	glPushMatrix();
		drawCities();
		earth -> Draw();
		drawPowerPoints(true);
		drawScore(nWidth/3,nHeight - 20);
		explosions.drawPoints();
		missiles.drawPoints();
		pinger.drawPoints();
	glPopMatrix();
}

void drawPreGame()
{
	string temp = "MISSILE COMMAND";
	renderText((char *) temp.c_str(),playerTextX,playerTextY / 2);
	temp = "Players push any key now";
	renderText((char *) temp.c_str(),playerTextX,playerTextY);
	for(int i = 0; i < (int) players.size(); i ++) {
		stringstream s;
		glPushAttrib(GL_CURRENT_BIT);
		applyColour(i);
		s << "Player " << (i + 1) << " added - " << getColourString(i) << " coloured city";
		temp = s.str();
		renderText((char *) temp.c_str(),playerTextX,playerTextY + (i + 2) * 20);
		glPopAttrib();
	}
}

void drawPostGame()
{
	string temp = "GAME OVER";
	renderText((char *) temp.c_str(),playerTextX,playerTextY);
	drawScore(playerTextX,playerTextY + 40);
	temp = "Press any key to restart game";
	renderText((char *) temp.c_str(),playerTextX,playerTextY + 100);
}

void drawCities()
{
	for(int i = 0; i < (int)cities.size(); i ++) {
		if(drawAllCities || cities[i]->IsActive())
			cities[i]->Draw();
	}
}

void drawPlayers()
{
	for(int i = 0; i < (int) players.size(); i ++) {
		if(players[i].GetCity() != NO_CITY)
			players[i].Draw();
	}
}

void drawPowerPoints(const bool asStd)
{
	for(int i = 0; i < (int) players.size(); i ++) {

		if(players[i].GetCity() != NO_CITY && (players[i].ClassicAim() || (players[i].CanFire() && asStd))) {
			players[i].AimDraw();
		}
	}
}