#include "explosion.h"

Explosions::Explosions(float red, float green, float blue){
	count = 0;
	r = red;
	g = green;
	b = blue;
	speed = 0;
	flag = false;
}

void Explosions::drawPoints(){
	int i;
	glPushAttrib(GL_CURRENT_BIT);
	for(i = count-1; i >= 0; i--){
	// for(i = 0; i < count; i++){
		glBegin(GL_TRIANGLE_FAN);
		if(points[i].life > 0.5)
			glColor4f(r + (RAND_UNIT-0.5)/5,g + (RAND_UNIT-0.5)/5,b + (RAND_UNIT-0.5)/5, 1.0);
		else if(points[i].life > 0.25){
			float red = r + (RAND_UNIT-0.5)/5;
			float green = g + (RAND_UNIT-0.5)/5;
			float blue = b + (RAND_UNIT-0.5)/5;
			glColor4f((red + points[i].life)/2, (green + points[i].life)/2, (blue + points[i].life)/2, points[i].life*2);
		}
		else
			glColor4f(0.5, 0.5, 0.5, points[i].life*2);
		glVertex2f(points[i].Pos.x, points[i].Pos.y);
		for(float j = 0.0; j < 2*PI; j += PI/32){
			//uses speed as a radius check
			points[i].speed = (LIFETIME-points[i].life)/(LIFETIME*15)+0.01;
			float randomNum = (RAND_UNIT/5)+0.9;
			glVertex2f(points[i].Pos.x + cos(j)*points[i].speed * randomNum, 
					   points[i].Pos.y + sin(j)*points[i].speed * randomNum);
		}
		glEnd();
	}
	glPopAttrib();
}

void Explosions::updatePoints(float dt){
	int i;

	for(i = 0; i < count; i++){
		//calculate life
		points[i].life -= dt;
		if(points[i].life < 0.0){
			//delete if life is too low
			deletePoint(i);
		}
	}
}

void Explosions::createPoint(vec2f posSet, float heading){
	Particle tempPart;
	if(count >= cMax)
		deletePoint(0);

	tempPart.Pos.x = posSet.x;
	tempPart.Pos.y = posSet.y;
	tempPart.speed = speed;
	
	//gives a particle time to live
	tempPart.life = LIFETIME;
	
	points.push_back(tempPart);
	count ++;
}

void Explosions::detectCollision(){
	vector<ParticleContainer*>::iterator itr;
	
	if(colliders.empty())
		return;

	for(itr = colliders.begin(); itr != colliders.end(); itr++){
		Particle expld = getNext();
		while(expld.life >= 0.0){
			Particle pt = (*itr)->getNext();
			int i = 0;
			while(pt.life >= 0.0){
				vec2f distance;
				distance = pt.Pos - expld.Pos;
				if(distance.sizesq() < expld.speed*expld.speed){
					pt = (*itr)->getNext();
					(*itr)->deletePoint(i);
					continue;
				}
				pt = (*itr)->getNext();
				i ++;
			}
			expld = getNext();
		}
	}
}

void Explosions::addCollider(ParticleContainer * rkt){
	colliders.push_back(rkt);
}