#include "glenable.h"
#include "control.h"
#include <cmath>


float fps = 0;
const float pi = acosf(-1);

void ReSizeGLScene(GLsizei width, GLsizei height)
{
	if(height == 0) height = 1;
	nWidth = width;
	nHeight = height;
	glViewport(0, 0, width, height);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	/*
	cout << width << " " << height << " " << (float) ((float) width / (float) height)<<" ratio\n";
	cout << Max << " " << Min << endl;
	cout << (Max.x - Min.x) / (Max.y - Min.y) << endl;
	*/
	//gluPerspective(75.0, (float)width / (float)height, 0.1, 1000.0);
	if(gameMode == EARTH && (float) ((float) width / (float) height) != ( (Max.x - Min.x )/ (Max.y - Min.y))) {
		float half = Max.x - ((Max.x - Min.x) / 2);
		float factor = (float) ((float) width / (float) height);
		factor *= (Max.y - Min.y);
		Max.x = half + factor / 2;
		Min.x = half - factor / 2;
	}
	/*
	cout << width / height << " ratio\n";
	cout << Max << " " << Min << endl;
	cout << (Max.x - Min.x) / (Max.y - Min.y) << endl;
	*/
	glOrtho(Min.x,Max.x,Min.y,Max.y,-1,1);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

void resetOrthoView(float minx, float miny, float maxx, float maxy)
{
	Min.x = minx;
	Min.y = miny;
	Max.x = maxx;
	Max.y = maxy;
	ReSizeGLScene(nWidth,nHeight);
}

void renderText(char * buffer, int xoffset, int yoffset)
{
	glPushAttrib(GL_ENABLE_BIT);
	glDisable(GL_DEPTH_TEST);
	glDisable(GL_LIGHTING);

	/* apply an orthographic projection temporarily */
	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();
	glOrtho(0, nWidth, 0, nHeight, -1, 1);

	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glLoadIdentity();

	/* draw the string */
	char * bufp;
	glRasterPos2i(xoffset, nHeight - yoffset);
	for(bufp = buffer; *bufp; bufp++)
		glutBitmapCharacter(GLUT_BITMAP_9_BY_15, *bufp);

	glPopMatrix();	/* Pop modelview */
	glMatrixMode(GL_PROJECTION);

	glPopMatrix();	/* Pop projection */
	glMatrixMode(GL_MODELVIEW);

	glPopAttrib();
}

void drawFrameRate(float fps)
{
	char buffer[32];
	//snprintf(buffer,32,"FPS: %.2f",fps);
	sprintf(buffer, "FPS: %.2f",fps);

	/* draw the string */
	renderText(buffer,10,20);
}

void drawCircle(float radius, int subs, float xstart, float ystart)
{
	/* draws a polygon with same length sides */
	int i;
	float theta;

	glBegin(GL_LINE_LOOP);
	for (i = 0; i <= subs; ++i) {
		theta = 2.0 * i * pi / subs;
		glVertex2f(xstart + radius * cos(theta), ystart + radius * sin(theta));
	}
	glEnd();
}

void drawHalfCircle(float radius, int subs, float xstart, float ystart)
{
	int i;
	float theta;

	glBegin(GL_LINE_LOOP);
	for (i = 0; i <= subs / 2; ++i) {
		theta = 2.0 * i * pi / subs;
		glVertex2f(xstart + radius * cos(theta), ystart + radius * sin(theta));
	}
	glEnd();
}

void displayInfo()
{
	cout << "\n\n\n";
	cout << "GAME INFORMATION\n";
	cout << "----------------\n\n";
	cout << "Missiles will try to destroy your base. Aim your cannon and fire missiles of your own to protect it\n";
	cout << "You base can only sustain 3 hits before it is destroyed\n";
	cout << "Game designed for a maximum of 8 players\n";
	cout << "Each player has their own city, controlled by a USB connected keyboard\n\n";
	cout << "Key bindings: \n\n";
	cout << "Left arrow key - aims left\n";
	cout << "Eight arrow key - aims right\n";
	cout << "Spacebar - shoots\n";
	cout << "Enter - joins game (if space to do so)\n";
	cout << "Tab - switches city (if space to do so)\n";
	cout << "\tNB: Both switching and joining will take you as close to the center as possible\n";
	cout << "Escape - gets a player out of the game, frees the city for another player to join\n";
	cout << "P key - pings your base, so you can tell which base you control\n";
	cout << "Q key - closes the program\n";
	cout << "I key - displays information\n";
}