#ifndef OPENGL_H
#define OPENGL_H

#include <windows.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>

#include <ctime>
#include <vector>

#include "rawwin.h"
#include "vec.h"

#define FRAME_TIME 1
#define PIXEL_FLAGS (PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER)
#define GL_STYLE_FLAGS (WS_OVERLAPPEDWINDOW)

extern LONG nWidth;		// width of window
extern LONG nHeight;	// height of window
extern float fps;		// for framerate
extern vec2f Min;	// for screen resizing
extern vec2f Max;

void drawFrameRate(float fps);
void renderText(char * buffer, int xoffset, int yoffset);
void ReSizeGLScene(GLsizei width, GLsizei height);
void resetOrthoView(float minx, float miny, float maxx, float maxy);
void drawCircle(float radius, int subs, float xstart = 0, float ystart = 0);
void drawHalfCircle(float radius, int subs, float xstart = 0, float ystart = 0);
void displayInfo();

#endif