#ifndef PROJECTILES_H
#define PROJECTILES_H

#include <vector>
#include "utils.h"
#include "vec.h"

struct Particle{
	vec2f Pos;
	vec2f Vel;
	float speed;
	float life;
};

class ParticleContainer{
public:
	vector<Particle> points;
	vector<Particle>::iterator it;
	int count;
	float r, g, b;
	float speed;
	bool flag;

public:
	ParticleContainer(float red = 1.0, float green = 1.0, float blue = 1.0, float spd = 0.0);
	// virtual ~ParticleContainer();
	virtual void drawPoints();
	//update the points positions and life value, and determine if it should die
	virtual void updatePoints(float dt);

	//creates a point
	//random heading
	virtual void createPoint();
	//set heading
	virtual void createPoint(vec2f posSet, float heading = -1.0);
	//position to aim towards
	virtual void createPoint(vec2f posSet, vec2f posAim);

	//deletes the point 'i'
	void deletePoint(int i);
	//clears the points structure
	void erase();
	//returns the particles in order
	Particle getNext();
	//Changes the colour
	void changeColour(float red, float green, float blue);
	// JAMES ADDED - SORRY CLARK
	void setSpeed(float spd = 0.0);
	int size();
	
	void ring(vec2f posSet);
	void burst(vec2f posSet);
};

#endif
