#include "rocketTrail.h"

RocketTrail::RocketTrail(){
	count = 0;
}

void RocketTrail::drawPoints(){
	int i;
	float colour;
	glPushAttrib(GL_CURRENT_BIT);
	glPointSize(2);
	glBegin(GL_POINTS);
	for(i = 0; i < count; i++){
		if(points[i].life > 0.75){
			colour = points[i].life;
			glColor3f(colour + RAND_UNIT/100, colour/2 + RAND_UNIT/100, 0);
		}
		else if(points[i].life > 0.5){
			float red = colour + RAND_UNIT/100;
			float green = colour/2 + RAND_UNIT/10;
			float blue = 0;
			glColor4f((red + points[i].life)/2, (green + points[i].life)/2, (blue + points[i].life)/2, points[i].life*4/3);
			
		}
		else{
			colour = points[i].life-0.25;
			glColor4f(colour + RAND_UNIT/100, colour + RAND_UNIT/100, colour + RAND_UNIT/100, points[i].life*4/3);
		}
		
		glVertex2f(points[i].Pos.x, points[i].Pos.y);
	}
	glEnd();
	glPointSize(1);
	glPopAttrib();
}

void RocketTrail::createPoint(vec2f posSet, vec2f posAim){
	Particle tempPart;
	if(count >= cMax*2)
		return;
	
	posAim.normalize();
	posAim *= -1;

	tempPart.Pos.x = posSet.x;
	tempPart.Pos.y = posSet.y;
	tempPart.Vel.x = posAim.x + (RAND_UNIT*2-1)/3;
	tempPart.Vel.y = posAim.y + (RAND_UNIT*2-1)/3;
	tempPart.Vel.normalize();
	tempPart.speed = RAND_UNIT/2;
	
	tempPart.life = 1;
	
	points.push_back(tempPart);
	count ++;
}
