#ifndef VEC_H
#define VEC_H

//#include "utils.h"
#include <cmath>
#include <iostream>
using namespace std;

struct vec2f
{
	float x, y;
	vec2f();
	explicit vec2f(float d);
	vec2f(float nx, float ny);
	void operator()(float d);
	void operator()(float nx, float ny);
	void operator=(float d);
	bool operator==(const vec2f& o);
	bool operator!=(const vec2f& o);
	vec2f operator+(const vec2f& o) const;
	void operator+=(const vec2f& o);
	vec2f operator+(float d) const;
	void operator+=(float d);
	vec2f operator-(const vec2f& o) const;
	void operator-=(const vec2f& o);
	vec2f operator-(float d) const;
	void operator-=(float d);
	vec2f operator/(const vec2f& o) const;
	void operator/=(const vec2f& o);
	vec2f operator/(float d) const;
	void operator/=(float d);
	vec2f operator*(const vec2f& o) const;
	void operator*=(const vec2f& o);
	vec2f operator*(float d) const;
	void operator*=(float d);
	float dot(const vec2f& other) const;
	float sizesq() const;
	float size() const;
	void normalize();
	vec2f unit() const;
};
vec2f operator-(vec2f v);
ostream& operator<<(ostream& out, const vec2f& v);

#endif
